org.apache.tinkerpop.gremlin.process.traversal.step.map

## Class AddEdgeStep<S>

- java.lang.Object
- - org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep<S,E>
  - - org.apache.tinkerpop.gremlin.process.traversal.step.map.MapStep<S,Edge>
    - - org.apache.tinkerpop.gremlin.process.traversal.step.map.AddEdgeStep<S>

- All Implemented Interfaces:
    Serializable, AutoCloseable, Cloneable, Iterator<Traverser.Admin<Edge>>, Step<S,Edge>, Configuring, FromToModulating, Mutating<Event.EdgeAddedEvent>, Parameterizing, Scoping, TraversalParent

      public class AddEdgeStep<S>
      extends MapStep<S,Edge>
      implements Mutating<Event.EdgeAddedEvent>, TraversalParent, Scoping, FromToModulating

  Author:
    Marko A. Rodriguez (http://markorodriguez.com), Stephen Mallette (http://stephen.genoprime.com)
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.Scoping

      `Scoping.Variable`

  - ### Field Summary

    - ### Fields inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `id, labels, nextEnd, nextStep, previousStep, starts, traversal, traverserStepIdAndLabelsSetByChild`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AddEdgeStep(Traversal.Admin traversal, String edgeLabel)`
    `AddEdgeStep(Traversal.Admin traversal, Traversal.Admin<S,String> edgeLabelTraversal)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addFrom(Traversal.Admin<?,?> fromObject)`
    `void` | `addTo(Traversal.Admin<?,?> toObject)`
    `AddEdgeStep<S>` | `clone()` Cloning is used to duplicate steps for the purpose of traversal optimization and OLTP replication.
    `void` | `configure(Object... keyValues)` Accept a configuration to the `Step`.
    `<S,E> List<Traversal.Admin<S,E>>` | `getLocalChildren()`
    `CallbackRegistry<Event.EdgeAddedEvent>` | `getMutatingCallbackRegistry()` Gets the callback registry for events that the step raises.
    `Parameters` | `getParameters()` Gets the parameters on the step.
    `Set<TraverserRequirement>` | `getRequirements()` Provide the necessary `TraverserRequirement` that must be met by the traverser in order for the step to function properly.
    `Set<String>` | `getScopeKeys()` Get the labels that this scoping step will access during the traversal
    `int` | `hashCode()`
    `protected Edge` | `map(Traverser.Admin<S> traverser)`
    `void` | `setTraversal(Traversal.Admin<?,?> parentTraversal)` Set the `Traversal` that this step is contained within.
    `String` | `toString()`

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.map.MapStep

      `processNextStart`

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `addLabel, addStart, addStarts, equals, getId, getLabels, getNextStep, getPreviousStep, getStarts, getTraversal, hasNext, isTraverserStepIdAndLabelsSetByChild, next, prepareTraversalForNextStep, removeLabel, reset, setId, setNextStep, setPreviousStep`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.TraversalParent

      `addGlobalChild, addLocalChild, asStep, close, getGlobalChildren, getSelfAndChildRequirements, integrateChild, removeGlobalChild, removeLocalChild`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.Scoping

      `getNullableScopeValue, getScopeValue`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.FromToModulating

      `addFrom, addTo`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.Step

      `equals`

    - ### Methods inherited from interface java.util.Iterator

      `forEachRemaining, remove`

- - ### Constructor Detail

    - #### AddEdgeStep

          public AddEdgeStep(Traversal.Admin traversal,
                             String edgeLabel)

    - #### AddEdgeStep

          public AddEdgeStep(Traversal.Admin traversal,
                             Traversal.Admin<S,String> edgeLabelTraversal)

  - ### Method Detail

    - #### getLocalChildren

          public <S,E> List<Traversal.Admin<S,E>> getLocalChildren()

      Specified by:
        `getLocalChildren` in interface `TraversalParent`

    - #### getParameters

          public Parameters getParameters()

      Description copied from interface: `Parameterizing`
      Gets the parameters on the step.
      Specified by:
        `getParameters` in interface `Parameterizing`

    - #### getScopeKeys

          public Set<String> getScopeKeys()

      Description copied from interface: `Scoping`
      Get the labels that this scoping step will access during the traversal
      Specified by:
        `getScopeKeys` in interface `Scoping`
      Returns:
        the accessed labels of the scoping step

    - #### configure

          public void configure(Object... keyValues)

      Description copied from interface: `Configuring`
      Accept a configuration to the `Step`. Note that this interface extends `Parameterizing` and so there is an expectation that the `Step` implementation will have a `Parameters` instance that will house any values passed to this method. Storing these configurations in `Parameters` is not a requirement however, IF the configuration is an expected option for the step and can be stored on a member field that can be accessed on the step by more direct means (i.e. like a getter method).
      Specified by:
        `configure` in interface `Configuring`

    - #### addTo

          public void addTo(Traversal.Admin<?,?> toObject)

      Specified by:
        `addTo` in interface `FromToModulating`

    - #### addFrom

          public void addFrom(Traversal.Admin<?,?> fromObject)

      Specified by:
        `addFrom` in interface `FromToModulating`

    - #### map

          protected Edge map(Traverser.Admin<S> traverser)

      Specified by:
        `map` in class `MapStep<S,Edge>`

    - #### getRequirements

          public Set<TraverserRequirement> getRequirements()

      Description copied from interface: `Step`
      Provide the necessary `TraverserRequirement` that must be met by the traverser in order for the step to function properly. The provided default implements returns an empty set.
      Specified by:
        `getRequirements` in interface `Step<S,Edge>`
      Returns:
        the set of requirements

    - #### getMutatingCallbackRegistry

          public CallbackRegistry<Event.EdgeAddedEvent> getMutatingCallbackRegistry()

      Description copied from interface: `Mutating`
      Gets the callback registry for events that the step raises.
      Specified by:
        `getMutatingCallbackRegistry` in interface `Mutating<Event.EdgeAddedEvent>`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `AbstractStep<S,Edge>`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `AbstractStep<S,Edge>`

    - #### setTraversal

          public void setTraversal(Traversal.Admin<?,?> parentTraversal)

      Description copied from interface: `Step`
      Set the `Traversal` that this step is contained within.
      Specified by:
        `setTraversal` in interface `Step<S,Edge>`
      Overrides:
        `setTraversal` in class `AbstractStep<S,Edge>`
      Parameters:
        `parentTraversal` - the new traversal for this step

    - #### clone

          public AddEdgeStep<S> clone()

      Description copied from interface: `Step`
      Cloning is used to duplicate steps for the purpose of traversal optimization and OLTP replication. When cloning a step, it is important that the steps, the cloned step is equivalent to the state of the step when `Step.reset()` is called. Moreover, the previous and next steps should be set to `EmptyStep`.
      Specified by:
        `clone` in interface `Step<S,Edge>`
      Overrides:
        `clone` in class `AbstractStep<S,Edge>`
      Returns:
        The cloned step

Copyright © 2013–2021 Apache Software Foundation. All rights reserved.